#include <iostream>
#include <sstream>

int xor_delilaca(int x)
{
    std::vector<int> delioci;
    for (int i = 1; i <= x; i++)
    {
        if (x % i == 0)
            delioci.push_back(i);
    }
    int xor_val = delioci[0];
    for (size_t i = 1; i < delioci.size(); i++)
        xor_val = xor_val ^ delioci[i];
    return xor_val;
}

int main()
{
    std::string line1, line2;
    std::getline(std::cin, line1);
    std::getline(std::cin, line2);

    std::istringstream iss1(line1);
    int n, k;
    iss1 >> n >> k;

    std::istringstream iss2(line2);
    std::vector<int> niz(k);
    for (int i = 0; i < k; i++)
        iss2 >> niz[i];

    for (int broj : niz)
        std::cout << xor_delilaca(broj) << " ";

    return 0;
}